package com.ashokit.tree;



import java.util.*;

//Class representing a Node in the Binary Tree
class TreeNode {
 int data;
 TreeNode left, right;

 public TreeNode(int data) {
     this.data = data;
     this.left = null;
     this.right = null;
 }
}

public class Test {

 // Method to get the left view of the binary tree
 public static void leftView(TreeNode root, ArrayList<Integer> result, int level) {
     // Base case
     if (root == null) {
         return;
     }

     // If this is the first node of the current level, add it to the result list
     if (result.size() == level) {
         result.add(root.data);
     }

     // Recurse for the left and then the right child
     leftView(root.left, result, level + 1);
     leftView(root.right, result, level + 1);
 }

 public static ArrayList<Integer> getLeftView(TreeNode root) {
     ArrayList<Integer> result = new ArrayList<>();
     leftView(root, result, 0);
     return result;
 }

 // Main method to test the left view functionality
 public static void main(String[] args) {
     // Create a binary tree
     TreeNode root = new TreeNode(1);
     root.left = new TreeNode(2);
     root.right = new TreeNode(3);
     root.left.left = new TreeNode(4);
     root.left.right = new TreeNode(5);
     root.right.left = new TreeNode(6);
     root.right.right = new TreeNode(7);
     root.left.left.left = new TreeNode(8);

     // Get the left view of the binary tree
     ArrayList<Integer> leftViewResult = getLeftView(root);

     // Print the left view
     System.out.println("Left view of the binary tree: " + leftViewResult);
 }
}
